"use client";
import Navbar from "@comp/landingComponents/Navbar";
import Footer from "@comp/landingComponents/Footer/page";
import React from "react";
import AboutUsHero from "@comp/landingComponents/AboutUsHero/page";

import ig from "../../../public/images/ig.png";
import tuk from "../../../public/images/tuk.png";
import Image from "next/image";

const AboutUs = () => {
  return (
    <div className="relative z-0 bg-black">
      <div className="bg-hero-pattern bg-cover bg-no-repeat bg-center">
        <Navbar />
        <AboutUsHero />
      </div>
      <div className="xs:px-[20px] lg:px-[120px] my-20">
        <p className="mb-0 sm:text-[20px] xs:text-[20px] lg:text-justify xs:text-left text-secondary  tracking-wider text-gray-300 font-thin">
          At Briz, we envision each coffee shop as a symphony, with every
          element from the espresso shot to the customer service playing in
          perfect harmony. Our journey began with the coming together of two
          innovative startups: 'Tuk Coffee,' a renowned delivery platform for
          brewed coffee with physical branches, and 'Igarson,' an accounting
          application tailored for coffee shops and restaurants. Our combined
          experience and passion for coffee shop excellence are the foundation
          of Briz.
        </p>
        <h2 className="text-white font-semibold md:text-[20px] sm:text-[20px] xs:text-[20px] text-[18px] mt-4">
          Our Team's Heritage
        </h2>
        <p className="mb-0 sm:text-[20px] xs:text-[20px] lg:text-justify xs:text-left text-secondary  tracking-wider text-gray-300 font-thin">
          Our team consists of six dedicated members, each bringing a unique
          blend of expertise and innovation from our roots in 'Tuk Coffee' and
          'Igarson.' We are baristas, managers, tech enthusiasts, and, above
          all, coffee lovers. Together, we've seen the challenges and triumphs
          of running coffee shops, and it's this rich experience that fuels our
          commitment to making Briz the ace of your coffee shop orchestr
        </p>

        <h2 className="text-white font-semibold md:text-[20px] sm:text-[20px] xs:text-[20px] text-[18px] mt-4">
          Our Team's Heritage
        </h2>

        <p className="mb-0 sm:text-[20px] xs:text-[20px] lg:text-justify xs:text-left text-secondary  tracking-wider text-gray-300 font-thin">
          We believe in the power of an efficiently managed coffee shop - where
          every task, every role, and every shift contributes to the delightful
          crescendo of customer satisfaction. Briz is not just an app; it's your
          partner in achieving this efficiency. It's the conductor's baton that
          helps you lead your coffee shop's symphony to play more harmoniously
          than ever before. With Briz, you're not just managing; you're
          performing.
        </p>

        <h2 className="text-white font-semibold md:text-[20px] sm:text-[20px] xs:text-[20px] text-[18px] mt-4">
          Our Commitment to Your Coffee Shop{" "}
        </h2>

        <p className="mb-0 sm:text-[20px] xs:text-[20px] lg:text-justify xs:text-left text-secondary  tracking-wider text-gray-300 font-thin">
          Our mission is simple yet ambitious: to empower coffee shops to manage
          their spaces with unprecedented efficiency and insight. Whether it's
          the bustling rush of the morning crowd or the relaxed ambiance of late
          evenings, Briz is there to ensure that every note of your coffee
          shop's day is pitch-perfect. Join us in redefining what it means to
          run a coffee shop, and let's make every cup of coffee an experience to
          remember.
        </p>
        <div className="flex justify-end my-10 ">
          <div className="mt-3">
            <Image src={tuk} className="w-[100px]" />
          </div>
          <div>
            <Image src={ig} className="w-[120px]" />
          </div>
        </div>
      </div>

      <Footer />
    </div>
  );
};

export default AboutUs;
