/** @type {import('tailwindcss').Config} */
module.exports = {
  content: [
    "./src/pages/**/*.{js,ts,jsx,tsx,mdx}",
    "./components/**/*.{js,ts,jsx,tsx,mdx}",
    "./src/app/**/*.{js,ts,jsx,tsx,mdx}",
    "./plugins/**/*.{js,ts,jsx,tsx,mdx}",
  ],
  theme: {
    extend: {
      colors: {
        backgroundPrimary: {
          100: "#FFFBE6",
        },
        primary: {
          50: "#f3faf3",
          100: "#e4f4e5",
          200: "#cbe7cc",
          300: "#9bd19d",
          400: "#70b873",
          500: "#4c9b4f",
          600: "#3a7f3e",
          700: "#316433",
          800: "#2a512c",
          900: "#244326",
          950: "#102312",
        },

        secondary: {
          50: "#f7f7f7",
          100: "#ededed",
          200: "#dbdbdb",
          300: "#c8c8c8",
          400: "#adadad",
          500: "#999999",
          600: "#888888",
          700: "#7b7b7b",
          800: "#676767",
          900: "#545454",
          950: "#363636",
        },

        danger: {
          50: "#fef2f2",
          100: "#fee2e2",
          200: "#ffc9c9",
          300: "#fda4a4",
          400: "#fa6f6f",
          500: "#f14242",
          600: "#de2424",
          700: "#bb1a1a",
          800: "#9b1919",
          900: "#801c1c",
          950: "#460909",
        },
        secondaryDark: {
          100: "#D03405",
        },
        secondaryLighter: {
          100: "#FFDACF",
        },
        textMain: {
          100: "#444444",
        },
        mainDisable: {
          100: "#888888",
        },
        info: {
          100: "#2B91EF",
          200: "#0061bd",
        },
        danger: {
          100: "#FF2C2C",
        },
        body: {
          100: "#EEEEEE",
        },
        colors: {
          primaryLand: "#050816",
          secondaryLand: "#aaa6c3",
          tertiaryLand: "#151030",
          "black-100": "#100d25",
          "black-200": "#090325",
          "white-100": "#f3f3f3",
        },
      },
    },

    screens: {
      xs: "290px",
      sm: "640px",
      // => @media (min-width: 640px) { ... }

      md: "768px",
      // => @media (min-width: 768px) { ... }

      lg: "1024px",
      // => @media (min-width: 1024px) { ... }

      xl: "1280px",
      // => @media (min-width: 1280px) { ... }

      "2xl": "1536px",
      // => @media (min-width: 1536px) { ... }
    },

    animation: {
      "spin-slow": "spin 8s linear infinite",
      "pulse-1": "pulse .7s linear ",
    },
  },
  plugins: [],
};
